<template>
  <v-card class="pt-4">
    <v-card-text :class="$vuetify.breakpoint.smAndDown ? 'dialog-content-scrollerd-smartphone' : 'dialog-content-scrollerd'">
      <v-form ref="form" @submit.prevent="validarFormulario">
        <v-text-field
          v-model="formProveedor.nombre"
          label="Nombre"
          type="text"
          :rules="rules.nombre"
          required
          autofocus
          color="accent"
        />
        <v-text-field
          v-model="formProveedor.dni"
          label="DNI"
          type="number"
          :rules="rules.dni"
          required
          color="accent"
        />
        <v-text-field
          v-model="formProveedor.telefono"
          label="Teléfono"
          type="text"
          :rules="rules.nombre"
          required
          color="accent"
        />
        <v-text-field
          v-model="formProveedor.ciudad"
          label="Ciudad"
          type="text"
          required
          color="accent"
        />
        <v-text-field
          v-model="formProveedor.direccion"
          label="Dirección"
          type="text"
          required
          color="accent"
        />
        <v-text-field
          v-model="formProveedor.email"
          label="E-mail"
          type="text"
          required
          color="accent"
        />
        <v-text-field
          v-model="formProveedor.web"
          label="Página web"
          type="text"
          required
          color="accent"
        />
      </v-form>
    </v-card-text>

    <v-card-actions :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
      <v-btn class="elevation-2 font-weight-light" @click="cerrarDialog()">
        Cerrar
      </v-btn>
      <v-spacer />
      <v-btn v-if="!isEditar" class="elevation-2 font-weight-light accent" @click="validarFormulario">
        Agregar
      </v-btn>
      <v-btn v-else class="elevation-2 font-weight-light accent" @click="validarFormulario">
        Modificar
      </v-btn>
    </v-card-actions>
  </v-card>
</template>

<script lang="ts">
import { Component, Prop, Ref, Vue } from 'vue-property-decorator'
import AppToast from '~/core/utils/AppToast'
import { AppStore } from '~/store/AppStore'
import { Proveedor } from '~/core/models/proveedor'
import { ProveedoresStore } from '~/store/ProveedoresStore'

    @Component
export default class formClientes extends Vue {
        @Ref('form') formulario;

        @Prop({ default: null }) proveedor!:Proveedor;

        menufecha:boolean = false;

        formProveedor:Proveedor = {
          direccion: '',
          nombre: '',
          dni: null,
          email: '',
          web: '',
          telefono: '',
          ciudad: null
        };

        rules = {
          nombre: [
            v => !!v || 'Campo requerido'
          ],
          dni: [
            v => !!v || 'Campo requerido',
            v => /^[0-9]*$/.test(v) || 'Solo debe ingresar números',
            v => /^[0-9]{5,15}$/.test(v) || 'El número no alcanza el mínimo de dígitos o supera el máximo de dígitos'
          ],
          email: [
            v => !!v || 'Campo requerido',
            v => /.+@.+/.test(v) || 'E-mail inválido'
          ]
        };

        get isEditar () {
          return this.proveedor
        }

        mounted () {
          if (this.isEditar) {
            this.cargarForm()
          }
        }

        private cargarForm () {
          Object.assign(
            this.formProveedor,
            this.proveedor
          )
        }

        cerrarDialog () {
          this.$emit('onClose')
        }

        validarFormulario () {
          if (this.formulario.validate()) {
            if (this.isEditar) {
              this.modificar()
            } else {
              this.guardar()
            }
          } else {
            AppToast.error('Campos inválidos')
          }
        }

        private async guardar () {
          AppStore.SHOW_LOADING('Guardando proveedor')

          try {
            await ProveedoresStore.registrarProveedores(this.formProveedor)
            this.cerrarDialog()
            AppToast.success('Proveedor registrado')
          } catch (e) {
          }
          AppStore.HIDE_LOADING()
        }

        private async modificar () {
          AppStore.SHOW_LOADING('Guardando proveedor')
          try {
            await ProveedoresStore.modificarProveedor(this.formProveedor)
            this.cerrarDialog()
            AppToast.success('Proveedor registrado')
          } catch (e) {
          }
          AppStore.HIDE_LOADING()
        }
}
</script>

<style lang="scss">

</style>
